<template>
    <div class="container">
        
        <h1 class="h1 margin-top">Horario</h1>
        <NuxtLink :to="`/user/get/horarios-${iduser}`">&#60; Ver Horarios del doctor(a) {{ userInfo.nombres }} {{ userInfo.apellidos }}.</NuxtLink>
        <div>
            <form @submit.prevent="submitForm">
                <table class="table" width="500px">
                    <tr>
                        <td width="150px">Día de la semana</td>
                        <td colspan="3">
                            <input type="hidden" name="id" v-model="horario.id" autocomplete="off" />
                            <input type="hidden" name="doctorId" v-model="horario.doctorId" autocomplete="off" />
                            <select name="diaSemana" v-model="horario.diaSemana">
                                <option value="-">Seleccione</option>
                                <option value="Lunes">Lunes</option>
                                <option value="Martes">Martes</option>
                                <option value="Miercoles">Miercoles</option>
                                <option value="Jueves">Jueves</option>
                                <option value="Viernes">Viernes</option>
                                <option value="Sábado">Sábado</option>
                                <option value="Domingo">Domingo</option>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td>Horario inicial</td>
                        <td>
                            <input type="time" name="horaInicio" v-model="horario.horaInicio" autocomplete="off" />
                        </td>
                        <td>Horario final</td>
                        <td>
                            <input type="time" name="horaFin" v-model="horario.horaFin" autocomplete="off" />
                        </td>
                    </tr>
                </table>
                <div>
                    <input type="submit" class="btn btn-primary" :value="currentAction.name" />
                </div>
            </form>
        </div>        
    </div>
</template>
<script lang="ts" setup>
    import { forceToTime } from '~/server/utils/common/date-and-time';
import { baseActionDetection } from '~/server/utils/forms/actionsDetector';

    const routerInstance = (useRouter());
    const iduser = ref((routerInstance.currentRoute.value.params.userid.toString()));
    const id = ref(routerInstance.currentRoute.value.params.id.toString());
    let currentAction = ref(baseActionDetection(parseInt(id.value), routerInstance.currentRoute.value));


    const userInfo:any = ref(await $fetch(`/api/user?id=${iduser.value}`, {   
        method: 'GET',
        headers: { 'method': 'findRecord' }
    }));

    const horario = ref({
        id: 0,
        diaSemana: "-",
        horaInicio: '00:00',
        horaFin: '00:00',
        doctorId: iduser.value
    });
    if (currentAction.value.index !== 0) {


        async function fetchInfo() {
            let hv:any = await $fetch(`/api/horario?id=${id.value}`,{
                method: 'GET',
                headers: { 'method': 'findRecord' }
            });
            hv.horaInicio = forceToTime(hv.horaInicio);
            hv.horaFin = forceToTime(hv.horaFin);
            horario.value = hv;
        }

        await fetchInfo();
    }

    async function submitForm() {
        await $fetch(`/api/horario`, {   
            method: 'POST',
            body: horario.value,
            headers: { 'method': currentAction.value.method }
        });
        navigateTo(`/user/get/horarios-${iduser.value}`);
    }
</script>
